/**   
 * adc.c
 *
 *
 *  Created on: 22.07.2010
 *      Author: ARV
 */

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr_helper.h>
#include <util/atomic.h>
#include "config.h"
#include "adc.h"
#include <util/delay.h>

/*
 *       

1.     AVCC,     REFS0   ADMUX
2.    BANDGAP,    ADMUX  14- , ..   MUX3, MUX2  MUX1
3.  BANDGAP  8  1,3 ,  .    5  (  -      )    1,3 / 5 * 1023 = 265
4.       3 ,   BANDGAP   1,3 / 3 * 1023 = 443
 ,           270 ( ),      -   270.     ,  ,  , ,    .

    :
http://www.rlocman.ru/shem/schematics.html?di=73220

 */
///    
//#define ADC_SAMPLE_COUNT 16							// -         (  )
//static volatile int16_t adc_data[ADC_SAMPLE_COUNT];	//     
//static uint8_t chanel = 0;							//      
//static volatile int8_t adc_status=0;
/*   :
													0     (  );
													-1  ;
													-2   (  )
													1   ,     adc_result_data;
*/

//static int16_t adc_result_data=0;					//    

/**    
 *     .
 */
/*ISR(ADC_vect){
	static uint8_t sample = 0;
	if (sample>ADC_SAMPLE_COUNT){
		sample=0;											//  , ..   -    adc_data
		adc_result_data=adc_result_data/ADC_SAMPLE_COUNT;	//      
		//adc_status=-2;										//  ,      
		adc_status=1;										//  
	}else{
		adc_result_data+=ADC;								//   
		//adc_data[sample] = ADC;							//       
		sample++;
		ADCSRA |= _BV(ADSC);								//    
	}
	adc_result_data=ADC;
	adc_status=1;
}*/

/**
 *       , .   adc_status
 * @return	  
 */
/*int8_t get_adc_status(){
	return adc_status;
}*/

/**
 *      1    
 * @param 
 * @return 0-    , 1-   ( )
 */
uint8_t get_battery_low(void){
	static int16_t adc_result_data=0;											//    

	ADMUX = ADMUX_BATTERY_METER;												//    - AVCC with external capacitor at AREF pin, VBG
	ADCSRA |= _BV(ADSC);														//    
	while(ADCSRA & _BV(ADSC));													//     
	adc_result_data=(((ADC_BANDGAP_VALUE+config.adc_bandgap_adj)*1024)/ADC);	//      *10
	if (adc_result_data<=BATTERY_LOW_NOTIFICATION){
		return 1;																//   
	}else{
		return 0;																//    
	}
}
/**
 *       
 * @param 
 * @return   *10
 */
uint16_t get_battery_voltage(void){

	//ADMUX |= ADMUX_BATTERY_METER;												//    - AVCC with external capacitor at AREF pin, VBG
	ADCSRA |= _BV(ADSC);														//    
	while(ADCSRA & _BV(ADSC));													//     
	return ((((ADC_BANDGAP_VALUE+config.adc_bandgap_adj)*1024)/ADC)+ADC_RESULT_ADJUSTMENT);	//      *10

}
/**
 *         ADC
 * @param 
 * @return   *10
 */
uint16_t get_battery_adc(void){

	//ADMUX |= ADMUX_BATTERY_METER;												//    - AVCC with external capacitor at AREF pin, VBG
	ADCSRA |= _BV(ADSC);														//    
	while(ADCSRA & _BV(ADSC));													//     
	return ADC;	//  ADC

}
/**
 *   
 * @param channel	 
 * @return 1-  ; 2-     
 */
/*uint8_t start_adc(uint8_t channel){
	//ADMUX|=channel;								//      
	ADCSRA |= _BV(ADSC);						//    
	adc_result_data=0;							//    
	if (adc_status==0) {
		adc_status=-1;							//  
		return 1;								//    
	}else{
		adc_status=-1;							//  
		return 2;								//    
	}
	return 1;								//    
}*/

/**
 *    
 * @return    
 */
/*int16_t get_adc_result(void){
	static long tmp = 0;
	if (adc_status!=1){
	for(uint8_t i=0; i<ADC_SAMPLE_COUNT; i++){
	      tmp += adc_data[i];
	   }
	   adc_result_data= tmp / ADC_SAMPLE_COUNT;
	   tmp=0;
	   adc_status=1;
	}
	   return adc_result_data;
}*/

/**  
 *
 * @param chanel   
 * @return    
 */
/*int16_t get_temp(uint8_t chanel){
	//         -  
	ATOMIC_BLOCK(ATOMIC_RESTORESTATE){
		return adc_data[chanel];
	}
}*/

/**  
 *        .
 * @param chanel   
 * @return   
 */
/*int16_t get_temperature(uint8_t chanel){
	return (get_temp(chanel) - config.offset[chanel]) * config.gain[chanel];
}*/

//   
void adc_init(void){
	///        .
	//ADCSRA = _BV(ADEN) | _BV(ADIE) | ADC_DIV_128;			//  ,   ,   - 
	ADCSRA = _BV(ADEN) | ADC_DIV_128;						//  ,   - 
	ADMUX=0;
	ADMUX = ADMUX_BATTERY_METER;							//    - AVCC with external capacitor at AREF pin, VBG
	_delay_ms(10);
	//ADCSRA |= _BV(ADSC);									//    
}

void adc_powerdown(){
	//     powerdown
	// The user is 	advised to write zero to ADEN before enter-ing such sleep modes to avoid excessive power consumption
	ADCSRA=0;
}
