/*********************************************

   
 : Version: Neon.1 Release (4.6.1) Build id: 20160913-0900, WinAVR 20100110
:
1.     USART   9600
2.   5   
3.    ,        (  )
4.     NRF,  3.12  .
5.  ,      (  ,    )

Device: atmega8L

Program:    5388 bytes (65.8% Full)
(.text + .data + .bootloader)

Data:         41 bytes (4.0% Full)
(.data + .bss + .noinit)

EEPROM:        9 bytes (1.8% Full)
(.eeprom)


Finished building: sizedummy

Linker argument: -Wl,-gc-sections
Compiller argument: -ffunction-sections

1.    INT -   
2.      -   
3.          -    0,  -  1
4.  ,  ,      
5. INT    ,      
6.      0,
7. .
8.   (   )    - .1

 *********************************************/
#include <avr/io.h>
#include <avr/interrupt.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <avr/pgmspace.h>
#include <avr/eeprom.h>
#include "avr_helper.h"
#include <util/delay.h>
#include "protocol.h"
#include "led.h"
#include "timer.h"
#include <stdio.h>
#include "adc.h"
#include "buttons.h"
#include <avr/sleep.h>
#include <avr/wdt.h>
#include "mirf.h"
#include "nRF24L01.h"
#include "com_io.h"
#include "config.h"


//static uint8_t cmd_buf[32];			//    

/**  ,       INT0.
 */
void go_sleep(void){
#if defined(DDRA)
	uint8_t porta, ddra;
#endif
	uint8_t ddrb, ddrc, ddrd;
	uint8_t portb, portc, portd;

	//    
#if defined(DDRA)
	ddra = DDRA;
#endif
	ddrb = DDRB;
	ddrc = DDRC;
	ddrd = DDRD;
#if defined(PORTA)
	porta = PORTA;
#endif
	portb = PORTB;
	portc = PORTC;
	portd = PORTD;

	//  
	mirf_power_down();							//  NRF
	nrf_print_config();
	_delay_ms(100);
	adc_powerdown();							//    powerdown    
	//_delay_ms(10);
	//   ,      
#if defined (PORTA)
	PORTA= 0;
#endif
	PORTB = 0;
	PORTC = 0;
	PORTD = 0;
#if defined(DDRA)
	DDRA = 0xFF;
#endif
	DDRB = 0xFF;
	DDRC = 0xFF;
	DDRD = 0xFF;
	//  -
	//OSCCAL = 0;

	//       
	// INT    ,      
	DDR(INT_PORT)&= ~ _BV(INT_PIN); 			// INT0 port configure as input
	PORT(INT_PORT)|= _BV(INT_PIN);				// and pullup

	DDR(KEY_PORT) |= KEY_ANY;					// output
	PORT(KEY_PORT) &= ~ KEY_ANY;				// not pullup
	DDR(KEY_FORWARD_PORT) |= KEY_FORWARD;		// output
	PORT(KEY_FORWARD_PORT) &= ~ KEY_FORWARD;	// not pullup

	// level interrupt INT0 (low level)
	MCUCR &= ~((1 << ISC01) | (1 << ISC00));
	// enable external interrupt
	GICR |= (1 << INT0);
	set_sleep_mode(SLEEP_MODE_PWR_DOWN);							//   = Powerdown
	sleep_enable();													//   
	sleep_cpu();
	sleep_disable();
	//      INT0
	// disable external interrupt here, in case the external low pulse is too long
	GICR &= ~(1 << INT0);

	//  -
	//OSCCAL = 0xFF;
	_delay_ms(10);
	//   
#if defined(PORTA)
	PORTA = porta;
#endif
	PORTB = portb;
	PORTC = portc;
	PORTD = portd;
#if defined(DDRA)
	DDRA = ddra;
#endif
	DDRB = ddrb;
	DDRC = ddrc;
	DDRD = ddrd;
	//  
	mirf_power_up();												//  NRF
}

SIGNAL(INT0_vect)
{
   // ISR might be empty, but is necessary nonetheless
	//led2_on();
    // disable external interrupt here, in case the external low pulse is too long
    //GICR &= ~(1 << INT0);
	asm("nop");
}


static buttons_t cur_state_port,last_state_port;
char tmp;
//param_receipt_t send_package;

int main(void){

    	key_init();
    	led_init();
    	timer1_init();								//      powerdown
    	adc_init();									//  

        printf_P(PSTR("START\r"));
        load_config(&config);						//   
        config.debug_on=ON;

		mirf_init();									//      NRF (, spi)
		_delay_ms(50);									//  
		printf_P(PSTR("NRF config"));
		tmp=mirf_config();
		if (tmp==1){							//   NRF (, ,   ..)
			led2_on();
			printf_P(PSTR(" OK\r"));
			led2_off();
		}else{
			led1_on();
			printf_P(PSTR(" ERROR=%d\r"),tmp);
			led1_off();
		}
		_delay_ms(500);

		led1_on();
		led2_on();
		buzzer_on();
		_delay_ms(100);
		led1_off();
		led2_off();
		buzzer_off();


		nrf_print_status();
		nrf_print_config();
		nrf_print_setup();
		nrf_print_future();
		printf_P(PSTR("CD=%d\r"), mirf_read_register(CD));
		printf_P(PSTR("CHANEL=%d\r"), mirf_read_register(RF_CH));
		printf_P(PSTR("L_PAYLOAD=%d\r"), mirf_read_register(RX_PW_P0));
		sei(); // interrupt on, clock starts ticking now

        while(1){

        if (time_is_over(DELAY_POWERDONW)){
       		//   powerdown
        	printf_P(PSTR("sleeping\r"));
        	go_sleep();
        	printf_P(PSTR("wakeup\r"));
        	reset_timer(DELAY_POWERDONW);
       	}

        if (time_is_over(DELAY_REPEAT)){
        	printf_P(PSTR("battery measurement\r"));
        	printf_P(PSTR("battery voltage=%04d\r"),get_battery_adc());
			if (get_battery_low()){
				//printf_P(PSTR("battery voltage=%04d\r"),get_battery_adc());
				buzzer_on();
				_delay_ms(100);
				buzzer_off();
				_delay_ms(100);
				buzzer_on();
				_delay_ms(100);
				buzzer_off();
			}
        	reset_timer(DELAY_REPEAT);
       	}

		//    z      
		cur_state_port.byte = get_key();
		if (cur_state_port.byte && config.debug_on){
			led2_on();
		}else {
			led2_off();
		}

		// ,      
		if (cur_state_port.byte != last_state_port.byte){
			printf_P(PSTR("KEY= %02d\r"), cur_state_port.byte);
			 //    
			tmp=mirf_write((void*)&cur_state_port,sizeof(cur_state_port));

			 //   
			 printf_P(PSTR("KEY\t\t = %02d BACKRWARD=%x LEFT=%x RIGHT=%x BOOZ=%x BLINK=%x LAMP=%x FORWARD=%x\r"),
					  cur_state_port.byte,
					  cur_state_port.k_back,
					  cur_state_port.k_left,
					  cur_state_port.k_right,
					  cur_state_port.k_booz,
					  cur_state_port.k_blink,
					  cur_state_port.k_lamp,
					  cur_state_port.k_fwd
					  );
			printf_P(PSTR("SEND TO RADIO code=%d\r"),tmp);
			//      
			last_state_port.byte = cur_state_port.byte;
			reset_timer(DELAY_POWERDONW);	//     
		 }
		if (mirf_get_status()&(1<<RX_DR)) {
		 //    NRF,   ..   
			printf_P(PSTR("RX\r"));
			mirf_send_cmd(FLUSH_RX);
		}
}
}
